| IGLib 1.4 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Index
- Class Hierarchy
- Class Members

Static Public Member Functions | Static Private Member Functions

# IG::Neural::NeuralTadej Class Reference

List of all members.

## Static Public Member Functions
static void | ReadAnalysisRequest (string filePath, ref IVector parameters, ref bool reqcalcobj, ref bool reqcalcconstr, ref bool reqcalcgradobj, ref bool reqcalcgradconstr, ref string cd)
| Read the analysis data from data file Format: { { p1, p2, … }, { reqcalcobj, reqcalcconstr, reqcalcgradobj, reqcalcgradconstr }, cd }.
static void | GetAnalysisRequest (string requestString, ref IVector parameters, ref bool reqcalcobj, ref bool reqcalcconstr, ref bool reqcalcgradobj, ref bool reqcalcgradconstr, ref string cd)
| Read the analysis request data from data file Format: { { p1, p2, … }, { reqcalcobj, reqcalcconstr, reqcalcgradobj, reqcalcgradconstr }, cd }.
static void | ReadAnalysisResult (string filePath, ref IVector parameters, ref bool calcobj, ref bool calcconstr, ref bool calcgradobj, ref bool calcgradconstr, ref double obj, ref IVector constr, ref IVector dobjdp, ref IVector[] dconstr, ref int errorcode, ref bool reqcalcobj, ref bool reqcalcconstr, ref bool reqcalcgradobj, ref bool reqcalcgradconstr)
| Read the analysis result data from data file Format:
static void | GetAnalysisResult (string requestString, ref IVector parameters, ref bool calcobj, ref bool calcconstr, ref bool calcgradobj, ref bool calcgradconstr, ref double obj, ref IVector constr, ref IVector dobjdp, ref IVector[] dconstr, ref int errorcode, ref bool reqcalcobj, ref bool reqcalcconstr, ref bool reqcalcgradobj, ref bool reqcalcgradconstr)
| Read the analysis result data from data file Format:
static void | LoadTrainingDataCSVinOneLine (string filePath, int inputLenght, int outputLenght, bool namesSpecified, bool descriptionSpecified, bool titleSpecified, ref SampledDataSet trainingData, ref InputOutputDataDefiniton definitionData)
  | Loads training data and Definition data from single CSV file. Parameters:
  filePath | Path to the file where training data are saved.
  inputLenght | Lenght of input parameters.
  outputLenght | Lenght of output parameters.
  namesSpecified | Flag if names are specified in the file.
  descriptionSpecified | Flag if definitions (descriptions, defaultValue, boundDefiner, minValue, maxValue) are specified in the file.
  trainingData | Training data set.
  definitionData | Definition data set.
$A Tako78 Mar11; June27;.
static void | LoadTrainingDataCSV (string filePath, int inputLenght, int outputLenght, bool namesSpecified, bool titleSpecified, bool descriptionSpecified, ref SampledDataSet trainingData, ref InputOutputDataDefiniton definitionData)
  | Loads training data and Definition data from single CSV file. Parameters:
  filePath | Path to the file where training data are saved.
  inputLenght | Lenght of input parameters.
  outputLenght | Lenght of output parameters.
  namesSpecified | Flag if names are specified in the file.
  descriptionSpecified | Flag if descriptions are specified in the file.
  trainingData | Training data set.
  definitionData | Definition data set.
$A Tako78 Apr11, June24;.
static void | LoadDefinitionDataCSV (string filePath, int inputLenght, int outputLenght, ref InputOutputDataDefiniton definitionData)
| Loads definition data from CSV file.
static void | SaveTrainingDataCSVinOneLine (string filePath, SampledDataSet trainingData, bool namesSpecified, bool titleSpecified, bool descriptionSpecified, InputOutputDataDefiniton definitionData)
| Saves training data and Definition data to single CSV file.
static void | SaveTrainingDataCSV (string filePath, SampledDataSet trainingData, bool namesSpecified, bool titlesSpecified, bool descriptionSpecified, InputOutputDataDefiniton definitionData)
| Saves training data and Definition data to single CSV file.
static void | SaveDefinitionDataCSV (string filePath, InputOutputDataDefiniton definitionData)
| Saves definition data to CSV file.
static void | SampledDataCombineOutputs (ref SampledDataSet result, params SampledDataSet[] individualSets)
| Loads training data and Definition data from multible CSV files. Training data consist of one output and multiple input parameters. Input parameters are the same in all files, output parameter are different.
static void | LoadTrainingDataCombinedOutputsJSON (ref SampledDataSet trainingData, string directoryPath, params string[] fileNames)
| Loads training data and Definition data from multible CSV files. Training data consist of one output and multiple input parameters. Input parameters are the same in all files, output parameter are different.
static void | LoadTrainingDataCombinedOutputsJSON (ref SampledDataSet trainingData, params string[] fileNames)
| Loads training data and Definition data from multible CSV files. Training data consist of one output and multiple input parameters. Input parameters are the same in all files but output parameter should be different.
static void | SaveTrainingDataJson (string filePath, SampledDataSet trainingData)
| Saves network's training data to the specified JSON file. File is owerwritten if it exists.
static void | SaveDefinitionDataJson (string filePath, InputOutputDataDefiniton trainingData)
| Saves network's definition data to the specified JSON file. File is owerwritten if it exists.
static void | LoadSampledDataJson (string filePath, ref SampledDataSet trainingData)
| Restores training data from the specified file in JSON format.
static void | LoadDefinitionDataJson (string filePath, ref InputOutputDataDefiniton definitionData)
| Restores definition data from the specified file in JSON format.
static double | getStandardDeviation (List< double > doubleList)
| Returns the standard deviation.
static void | SmoothingTrainingData (SampledDataSet trainingData, ref SampledDataSet smoothTrainingData, double numStandardDeviation, bool uniqueInput, bool uniqueOutput, bool zeroData)
| Check the training data set and delete unconsistant datas.
static INeuralApproximator | ExampleCasting (int inputLength, int outputLength, ref SampledDataSet trainingData)
static INeuralApproximator | ExampleStore (int inputLength, int outputLength, ref SampledDataSet trainingData)
static INeuralApproximator | TrainNetwork (ref INeuralApproximator neuralApp)
static void | StoreNetwork (string directoryPath, string fileName, string internalStateFileName, INeuralApproximator neuralApp, bool saveRestored)
static INeuralApproximator | ExampleQuadratic (int inputLength, int outputLength)
static void | neuronsDataRange (SampledDataSet trainingData, ref List< double[]> inputColumnSet, double inputlowerBound, double inputupperBound, ref List< double[]> outputColumnSet, double outputlowerBound, double outputupperBound)
static void | CopyTrainingData (SampledDataSet trainingData, ref SampledDataSet newtrainingData)
| Copy training data set to new training data set.
## Static Private Member Functions
static void | TestArray0Elements ()
| Creates an array with 0 elements.

## Member Function Documentation

static void IG::Neural::NeuralTadej::ReadAnalysisRequest | ( | string | filePath,
|  | ref IVector | parameters,
|  | ref bool | reqcalcobj,
|  | ref bool | reqcalcconstr,
|  | ref bool | reqcalcgradobj,
|  | ref bool | reqcalcgradconstr,
|  | ref string | cd
| ) |  | `[inline, static]`

Read the analysis data from data file Format: { { p1, p2, … }, { reqcalcobj, reqcalcconstr, reqcalcgradobj, reqcalcgradconstr }, cd }.

Parameters:

  filePath | Path to the file where training data are saved.
  parameters | Input and output parameters: { p1, p2, … }.
  reqcalcobj | Flag: reqcalcobj.
  reqcalcconstr | Flag: reqcalcconstr.
  reqcalcgradobj | Flag: reqcalcgradobj.
  reqcalcgradconstr | Flag: reqcalcgradconstr.
  cd | String: cd.

$A Tako78 Mar11;

static void IG::Neural::NeuralTadej::GetAnalysisRequest | ( | string | requestString,
|  | ref IVector | parameters,
|  | ref bool | reqcalcobj,
|  | ref bool | reqcalcconstr,
|  | ref bool | reqcalcgradobj,
|  | ref bool | reqcalcgradconstr,
|  | ref string | cd
| ) |  | `[inline, static]`

Read the analysis request data from data file Format: { { p1, p2, … }, { reqcalcobj, reqcalcconstr, reqcalcgradobj, reqcalcgradconstr }, cd }.

Parameters:

  requestString | String with request analysis data.
  parameters | Input and output parameters: { p1, p2, … }.
  reqcalcobj | Flag: reqcalcobj.
  reqcalcconstr | Flag: reqcalcconstr.
  reqcalcgradobj | Flag: reqcalcgradobj.
  reqcalcgradconstr | Flag: reqcalcgradconstr.
  cd | String: cd.

$A Tako78 Mar11;

static void IG::Neural::NeuralTadej::ReadAnalysisResult | ( | string | filePath,
|  | ref IVector | parameters,
|  | ref bool | calcobj,
|  | ref bool | calcconstr,
|  | ref bool | calcgradobj,
|  | ref bool | calcgradconstr,
|  | ref double | obj,
|  | ref IVector | constr,
|  | ref IVector | dobjdp,
|  | ref IVector[] | dconstr,
|  | ref int | errorcode,
|  | ref bool | reqcalcobj,
|  | ref bool | reqcalcconstr,
|  | ref bool | reqcalcgradobj,
|  | ref bool | reqcalcgradconstr
| ) |  | `[inline, static]`

Read the analysis result data from data file Format:

Parameters:

  filePath | Path to the file where training data are saved.
  parameters | Input and output parameters: { p1, p2, … }.
  calcobj | Flag for the objective function.
  calcconstr | Flag for constraint functions.
  calcgradobj | Gradient of the objective function.
  calcgradconstr | Gradients of constraint functions.
  obj | Value of the objective functions.
  constr | Values of the constraint functions.
  dobjdp | Derivatives of the objective function.
  dconstr | Derivatives of individual constraint functions.
  errorcode | Integer error code of analysis.
  reqcalcobj | Flag for calculation of the various values.
  reqcalcconstr | Flag for calculation of the various values.
  reqcalcgradobj | Flag for calculation of the various values.
  reqcalcgradconstr | Flag for calculation of the various values.

$A Tako78 Apr7;

static void IG::Neural::NeuralTadej::GetAnalysisResult | ( | string | requestString,
|  | ref IVector | parameters,
|  | ref bool | calcobj,
|  | ref bool | calcconstr,
|  | ref bool | calcgradobj,
|  | ref bool | calcgradconstr,
|  | ref double | obj,
|  | ref IVector | constr,
|  | ref IVector | dobjdp,
|  | ref IVector[] | dconstr,
|  | ref int | errorcode,
|  | ref bool | reqcalcobj,
|  | ref bool | reqcalcconstr,
|  | ref bool | reqcalcgradobj,
|  | ref bool | reqcalcgradconstr
| ) |  | `[inline, static]`

Read the analysis result data from data file Format:

Parameters:

  resultString | String with result analysis data.
  parameters | Input and output parameters: { p1, p2, … }.
  calcobj | Flag for the objective function.
  calcconstr | Flag for constraint functions.
  calcgradobj | Gradient of the objective function.
  calcgradconstr | Gradients of constraint functions.
  obj | Value of the objective functions.
  constr | Values of the constraint functions.
  dobjdp | Derivatives of the objective function.
  dconstr | Derivatives of individual constraint functions.
  errorcode | Integer error code of analysis.
  reqcalcobj | Flag for calculation of the various values.
  reqcalcconstr | Flag for calculation of the various values.
  reqcalcgradobj | Flag for calculation of the various values.
  reqcalcgradconstr | Flag for calculation of the various values.

$A Tako78 Apr7;

static void IG::Neural::NeuralTadej::LoadTrainingDataCSVinOneLine | ( | string | filePath,
|  | int | inputLenght,
|  | int | outputLenght,
|  | bool | namesSpecified,
|  | bool | descriptionSpecified,
|  | bool | titleSpecified,
|  | ref SampledDataSet | trainingData,
|  | ref InputOutputDataDefiniton | definitionData
| ) |  | `[inline, static]`

Loads training data and Definition data from single CSV file.

Parameters:

  filePath | Path to the file where training data are saved.
  inputLenght | Lenght of input parameters.
  outputLenght | Lenght of output parameters.
  namesSpecified | Flag if names are specified in the file.
  descriptionSpecified | Flag if definitions (descriptions, defaultValue, boundDefiner, minValue, maxValue) are specified in the file.
  trainingData | Training data set.
  definitionData | Definition data set.

$A Tako78 Mar11; June27;.

static void IG::Neural::NeuralTadej::LoadTrainingDataCSV | ( | string | filePath,
|  | int | inputLenght,
|  | int | outputLenght,
|  | bool | namesSpecified,
|  | bool | titleSpecified,
|  | bool | descriptionSpecified,
|  | ref SampledDataSet | trainingData,
|  | ref InputOutputDataDefiniton | definitionData
| ) |  | `[inline, static]`

Loads training data and Definition data from single CSV file.

Parameters:

  filePath | Path to the file where training data are saved.
  inputLenght | Lenght of input parameters.
  outputLenght | Lenght of output parameters.
  namesSpecified | Flag if names are specified in the file.
  descriptionSpecified | Flag if descriptions are specified in the file.
  trainingData | Training data set.
  definitionData | Definition data set.

$A Tako78 Apr11, June24;.

static void IG::Neural::NeuralTadej::LoadDefinitionDataCSV | ( | string | filePath,
|  | int | inputLenght,
|  | int | outputLenght,
|  | ref InputOutputDataDefiniton | definitionData
| ) |  | `[inline, static]`

Loads definition data from CSV file.

Parameters:

  filePath | Path to the file where definition data are saved.
  inputLenght | Lenght of input parameters.
  outputLenght | Lenght of output parameters.
  definitionData | Definition data set.

$A Tako78 Mar11; June24;

static void IG::Neural::NeuralTadej::SaveTrainingDataCSVinOneLine | ( | string | filePath,
|  | SampledDataSet | trainingData,
|  | bool | namesSpecified,
|  | bool | titleSpecified,
|  | bool | descriptionSpecified,
|  | InputOutputDataDefiniton | definitionData
| ) |  | `[inline, static]`

Saves training data and Definition data to single CSV file.

Parameters:

  filePath | Path to the file where training data will be saved.
  trainingData | Training data set.
  namesSpecified | Flag if names will be written in the file.
  descriptionSpecified | Flag if descriptions (descriptions, defaultValue, boundDefiner, minValue, maxValue) will be written in the file.
  definitionData | Definition data set.

$A Tako78 Mar11; June27;

static void IG::Neural::NeuralTadej::SaveTrainingDataCSV | ( | string | filePath,
|  | SampledDataSet | trainingData,
|  | bool | namesSpecified,
|  | bool | titlesSpecified,
|  | bool | descriptionSpecified,
|  | InputOutputDataDefiniton | definitionData
| ) |  | `[inline, static]`

Saves training data and Definition data to single CSV file.

Parameters:

  filePath | Path to the file where training data will be saved.
  trainingData | Training data set.
  namesSpecified | Flag if names will be written in the file.
  descriptionSpecified | Flag if descriptions will be written in the file.
  definitionData | Definition data set.

$A Tako78 Mar11; June27;

static void IG::Neural::NeuralTadej::SaveDefinitionDataCSV | ( | string | filePath,
|  | InputOutputDataDefiniton | definitionData
| ) |  | `[inline, static]`

Saves definition data to CSV file.

Parameters:

  filePath | Path to the file where definition data will be saved.
  definitionData | Definition data set.

$A Tako78 Mar11; June27;

static void IG::Neural::NeuralTadej::SampledDataCombineOutputs | ( | ref SampledDataSet | result,
|  | params SampledDataSet[] | individualSets
| ) |  | `[inline, static]`

Loads training data and Definition data from multible CSV files. Training data consist of one output and multiple input parameters. Input parameters are the same in all files, output parameter are different.

Parameters:

  result | Training data set with combined outputs.
  individualSets | Different training data sets with the same inputs and different outputs.

$A Tako78 Mar11;

static void IG::Neural::NeuralTadej::LoadTrainingDataCombinedOutputsJSON | ( | ref SampledDataSet | trainingData,
|  | string | directoryPath,
|  | params string[] | fileNames
| ) |  | `[inline, static]`

Loads training data and Definition data from multible CSV files. Training data consist of one output and multiple input parameters. Input parameters are the same in all files, output parameter are different.

Parameters:

  trainingData | Training data set.
  directoryPath | Path to the file where training data are saved.
  fileNames | Name of the files where training data are saved.

$A Tako78 Mar11;

static void IG::Neural::NeuralTadej::LoadTrainingDataCombinedOutputsJSON | ( | ref SampledDataSet | trainingData,
|  | params string[] | fileNames
| ) |  | `[inline, static]`

Loads training data and Definition data from multible CSV files. Training data consist of one output and multiple input parameters. Input parameters are the same in all files but output parameter should be different.

Parameters:

  fileNames | Path to the file where training data are saved.
  trainingData | Training data set.

$A Tako78 Mar11;

static void IG::Neural::NeuralTadej::SaveTrainingDataJson | ( | string | filePath,
|  | SampledDataSet | trainingData
| ) |  | `[inline, static]`

Saves network's training data to the specified JSON file. File is owerwritten if it exists.

Parameters:

  filePath | Path to the file where training data is saved.

$A Tako78 Mar11;

static void IG::Neural::NeuralTadej::SaveDefinitionDataJson | ( | string | filePath,
|  | InputOutputDataDefiniton | trainingData
| ) |  | `[inline, static]`

Saves network's definition data to the specified JSON file. File is owerwritten if it exists.

Parameters:

  filePath | Path to the file where definition data is saved.

$A Tako78 Maj31;

static void IG::Neural::NeuralTadej::LoadSampledDataJson | ( | string | filePath,
|  | ref SampledDataSet | trainingData
| ) |  | `[inline, static]`

Restores training data from the specified file in JSON format.

Parameters:

  filePath | File from which training data is restored.

$A Tako78 Mar11;

static void IG::Neural::NeuralTadej::LoadDefinitionDataJson | ( | string | filePath,
|  | ref InputOutputDataDefiniton | definitionData
| ) |  | `[inline, static]`

Restores definition data from the specified file in JSON format.

Parameters:

  filePath | File from which definition data is restored.

$A Tako78 Nov11;

static double IG::Neural::NeuralTadej::getStandardDeviation | ( | List< double > | doubleList | ) | `[inline, static]`

Returns the standard deviation.

Parameters:

  trainingData | List of dataset.

$A Tako78 Apr11;

static void IG::Neural::NeuralTadej::SmoothingTrainingData | ( | SampledDataSet | trainingData,
|  | ref SampledDataSet | smoothTrainingData,
|  | double | numStandardDeviation,
|  | bool | uniqueInput,
|  | bool | uniqueOutput,
|  | bool | zeroData
| ) |  | `[inline, static]`

Check the training data set and delete unconsistant datas.

Parameters:

  trainingData | Training data set.
  smoothTrainingData | New training data set after.
  numStandardDeviation | Number of standard deviation.

$A Tako78 Apr11;

static INeuralApproximator IG::Neural::NeuralTadej::ExampleCasting | ( | int | inputLength,
|  | int | outputLength,
|  | ref SampledDataSet | trainingData
| ) |  | `[inline, static]`

Parameters:

  inputLength |
  outputLength |
  trainingData |

Returns:

$A Tako78 Mar11;

static INeuralApproximator IG::Neural::NeuralTadej::ExampleStore | ( | int | inputLength,
|  | int | outputLength,
|  | ref SampledDataSet | trainingData
| ) |  | `[inline, static]`

Parameters:

  inputLength |
  outputLength |
  trainingData |

Returns:

$A Tako78 Mar11;

static INeuralApproximator IG::Neural::NeuralTadej::TrainNetwork | ( | ref INeuralApproximator | neuralApp | ) | `[inline, static]`

static void IG::Neural::NeuralTadej::StoreNetwork | ( | string | directoryPath,
|  | string | fileName,
|  | string | internalStateFileName,
|  | INeuralApproximator | neuralApp,
|  | bool | saveRestored
| ) |  | `[inline, static]`

static INeuralApproximator IG::Neural::NeuralTadej::ExampleQuadratic | ( | int | inputLength,
|  | int | outputLength
| ) |  | `[inline, static]`

Parameters:

  inputLength |
  outputLength |

Returns:

$A Tako78 Mar11;

static void IG::Neural::NeuralTadej::neuronsDataRange | ( | SampledDataSet | trainingData,
|  | ref List< double[]> | inputColumnSet,
|  | double | inputlowerBound,
|  | double | inputupperBound,
|  | ref List< double[]> | outputColumnSet,
|  | double | outputlowerBound,
|  | double | outputupperBound
| ) |  | `[inline, static]`

Parameters:

  trainingData | Training Data.
  inputColumnSet | List of input Parameters.
  inputlowerBound | Lower coordinate input neurons range.
  inputupperBound | Upper coordinate input neurons range.
  outputColumnSet | List of output Parameters.
  outputlowerBound | Lower coordinate output neurons range.
  outputupperBound | Upper coordinate output neurons range.

$A Tako78 June20;

static void IG::Neural::NeuralTadej::CopyTrainingData | ( | SampledDataSet | trainingData,
|  | ref SampledDataSet | newtrainingData
| ) |  | `[inline, static]`

Copy training data set to new training data set.

/

Parameters:

  trainingData | Training data set.
  newtrainingData | New training data set.

static void IG::Neural::NeuralTadej::TestArray0Elements | ( |  | ) | `[inline, static, private]`

Creates an array with 0 elements.

$A Tako78 Mar11;

The documentation for this class was generated from the following file:

- NeuralTadej.cs

All Classes Namespaces Files Functions Variables Enumerations Properties Events